/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.ldt.shop.controller;

import cn.hutool.core.lang.Assert;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.ldt.mall.service.IMallService;
import org.springblade.modules.ldt.mallarea.service.IMallAreaService;
import org.springblade.modules.ldt.mallshoplabel.entity.MallShopLabel;
import org.springblade.modules.ldt.mallshoplabel.service.IMallShopLabelService;
import org.springblade.modules.ldt.shop.wrapper.ShopWrapper;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.ldt.shop.entity.Shop;
import org.springblade.modules.ldt.shop.vo.ShopVO;
import org.springblade.modules.ldt.shop.service.IShopService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-07-28
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-ldt/shop")
@Api(value = "", tags = "接口")
public class ShopController extends BladeController {

	private final IShopService shopService;
	private final IMallShopLabelService mallShopLabelService;
	private final IMallService mallService;
	private final IMallAreaService mallAreaService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入shop")
	public R<ShopVO> detail(Shop shop) {
		Shop detail = shopService.getOne(Condition.getQueryWrapper(shop));
		return R.data(ShopWrapper.build(mallAreaService,mallService).entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入shop")
	public R<IPage<Shop>> list(Shop shop, Query query) {
		IPage<Shop> pages = shopService.page(Condition.getPage(query), Condition.getQueryWrapper(shop));
		return R.data(pages);
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入shop")
	public R<IPage<ShopVO>> page(ShopVO shop, Query query) {
		IPage<ShopVO> pages = shopService.selectShopPage(Condition.getPage(query), shop);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入shop")
	public R save(@Valid @RequestBody Shop shop) {
		return R.status(shopService.save(shop));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入shop")
	public R update(@Valid @RequestBody Shop shop) {
		return R.status(shopService.updateById(shop));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入shop")
	public R submit(@Valid @RequestBody Shop shop) {
		String labelId = shop.getLabelIds();
		String[] labelIds = labelId.split(",");
		StringBuffer sb = new StringBuffer();
		for(String label : labelIds){
			MallShopLabel mallShopLabel = mallShopLabelService.getById(Long.valueOf(label));
			sb.append(mallShopLabel.getName()+",");
		}
		shop.setLabelNames(sb.toString().substring(0,sb.toString().length()-1));
		return R.status(shopService.saveOrUpdate(shop));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(shopService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 商户审核
	 */
	@PostMapping("/audit")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "商户审核", notes = "传入ids")
	public R audit(@RequestBody Shop shop) {
		Shop oldEntity = shopService.getById(shop.getId());
		Assert.notNull(oldEntity,"商户不存在");
		oldEntity.setAuditStatus(shop.getAuditStatus());

		return R.status(shopService.updateById(oldEntity));
	}


}
